var $form = $('#paymentForm');

$("#btnCancel").click(function () {
    if (document.referrer == "") {
        window.location = "/Invoices";
    } else {
        history.back()
    }
});

$("#btnSubmit").click(function (e) {
    if ($("label.error").length <= 0) {
        // only show the overlay if there aren't any validation errors
        $('#loadingOverlay').show();
    }
});

/* Fancy restrictive input formatting via jQuery.payment library*/
$("input[name='CreditCardInformation.CreditCardNumber']").payment('formatCardNumber');
$("input[name='CreditCardInformation.ExpirationDate']").payment('formatCardExpiry');
$("input[name='CreditCardInformation.CreditCardCV']").payment('formatCardCVC');

/* Form validation using Stripe client-side validation helpers */
jQuery.validator.addMethod("cardNumber", function (value, element) {
    return this.optional(element) || Stripe.card.validateCardNumber(value);
}, "Please specify a valid credit card number.");

jQuery.validator.addMethod("cardExpiry", function (value, element) {
    /* Parsing month/year uses jQuery.payment library */
    value = $.payment.cardExpiryVal(value);
    return this.optional(element) || Stripe.card.validateExpiry(value.month, value.year);
}, "Invalid expiration date.");

jQuery.validator.addMethod("cardCVC", function (value, element) {
    return this.optional(element) || Stripe.card.validateCVC(value);
}, "Invalid CVC.");

jQuery.validator.addMethod("zipcode", function (value, element) {
    return this.optional(element) || /^\d{5}(?:[\s-]\d{4})?$/.test(value);
}, "Invalid zip code.");

jQuery.validator.addMethod('phoneUS', function (a, b) {
    return a = a.replace(/\s+/g, ''),
        this.optional(b) || a.length > 9 && a.match(/^(\+?1-?)?(\([2-9]([02-9]\d|1[02-9])\)|[2-9]([02-9]\d|1[02-9]))-?[2-9]([02-9]\d|1[02-9])-?\d{4}$/)
}, "Please specify a valid phone number.");

jQuery.validator.addMethod("lettersonly", function (value, element) {
    return this.optional(element) || /^[a-z]+$/i.test(value);
}, "Letters only please");

$.validator.addMethod("regex",
    /* The function that tests a given string against a given regEx. */
    function (value, element, regexp) {
        /* Check if the value is truthy (avoid null.constructor) & if it's not a RegEx. */
        if (regex && regexp.constructor != RegExp) {
            /* Create a new regular expression using the regex argument. */
            regexp = new RegExp(regexp);
        }

        /* Check whether the argument is global and, if so set its last index to 0. */
        else if (regexp.global) regexp.lastIndex = 0;

        /* Return whether the element is optional or the result of the validation. */
        return this.optional(element) || regexp.test(value);
    }
);

validator = $form.validate({
    rules: {
        "CreditCardInformation.CreditCardName": {
            required: true
        },
        "CreditCardInformation.CreditCardNumber": {
            required: true,
            cardNumber: true
        },
        "CreditCardInformation.ExpirationDate": {
            required: true,
            cardExpiry: true
        },
        "CreditCardInformation.CreditCardCV": {
            required: true,
            cardCVC: true
        },

        // billing rules
        "BillingInformation.FirstName": {
            required: true
        },
        "BillingInformation.LastName": {
            required: true
        },
        "BillingInformation.Street1": {
            required: true
        },
        "BillingInformation.City": {
            required: true
        },
        "BillingInformation.ZIPOrPostalCode": {
            required: true,
            //zipcode: true
        },
        "BillingInformation.StateOrProvince": {
            required: true
        },
        "BillingInformation.Country": {
            required: true
        },
        "BillingInformation.Email": {
            required: true,
            email: true,
            regex: /^\b[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}\b$/i
        }
    },
    //highlight: function (element) {
    //    $(element).closest('.form-control').removeClass('success').addClass('error');
    //},
    //unhighlight: function (element) {
    //    $(element).closest('.form-control').removeClass('error').addClass('success');
    //},
    errorPlacement: function (error, element) {
        $(element).closest('.form-group').append(error);
        $('#loadingOverlay').hide();
    }
});